{"openapi":"3.0.1","info":{"title":"Merchant Schedules"},"servers":[{"url":"https://api-third-party-gtm-pp.grubhub.com","description":"preprod"},{"url":"https://api-third-party-gtm.grubhub.com","description":"prod"}],"tags":[{"name":"Models","description":"# LocalTime \n <SchemaDefinition schemaRef=\"#/components/schemas/LocalTime\"/>\n\n# PosMerchantRepeatingIntervalRequest \n <SchemaDefinition schemaRef=\"#/components/schemas/PosMerchantRepeatingIntervalRequest\"/>\n\n# PosUpdateRepeatingScheduleRequest \n <SchemaDefinition schemaRef=\"#/components/schemas/PosUpdateRepeatingScheduleRequest\"/>\n\n# Chronology \n <SchemaDefinition schemaRef=\"#/components/schemas/Chronology\"/>\n\n# DateTimeField \n <SchemaDefinition schemaRef=\"#/components/schemas/DateTimeField\"/>\n\n# DateTimeFieldType \n <SchemaDefinition schemaRef=\"#/components/schemas/DateTimeFieldType\"/>\n\n# DateTimeZone \n <SchemaDefinition schemaRef=\"#/components/schemas/DateTimeZone\"/>\n\n# DurationField \n <SchemaDefinition schemaRef=\"#/components/schemas/DurationField\"/>\n\n# DurationFieldType \n <SchemaDefinition schemaRef=\"#/components/schemas/DurationFieldType\"/>\n\n# PosMerchantRepeatingSchedule \n <SchemaDefinition schemaRef=\"#/components/schemas/PosMerchantRepeatingSchedule\"/>\n\n# RepeatingSchedule \n <SchemaDefinition schemaRef=\"#/components/schemas/RepeatingSchedule\"/>\n\n# RepeatingScheduleMetadata \n <SchemaDefinition schemaRef=\"#/components/schemas/RepeatingScheduleMetadata\"/>\n\n# RepeatingScheduleRule \n <SchemaDefinition schemaRef=\"#/components/schemas/RepeatingScheduleRule\"/>\n\n# RepeatingScheduleRuleInterval \n <SchemaDefinition schemaRef=\"#/components/schemas/RepeatingScheduleRuleInterval\"/>\n\n# PosScheduleOverrideRequest \n <SchemaDefinition schemaRef=\"#/components/schemas/PosScheduleOverrideRequest\"/>\n\n# CustomScheduleMetadata \n <SchemaDefinition schemaRef=\"#/components/schemas/CustomScheduleMetadata\"/>\n\n# MassScheduleOverrideMetadata \n <SchemaDefinition schemaRef=\"#/components/schemas/MassScheduleOverrideMetadata\"/>\n\n# PeriodSchedule \n <SchemaDefinition schemaRef=\"#/components/schemas/PeriodSchedule\"/>\n\n# PosCustomSchedule \n <SchemaDefinition schemaRef=\"#/components/schemas/PosCustomSchedule\"/>\n\n# PosFullSchedule \n <SchemaDefinition schemaRef=\"#/components/schemas/PosFullSchedule\"/>\n\n# PosMassScheduleOverride \n <SchemaDefinition schemaRef=\"#/components/schemas/PosMassScheduleOverride\"/>\n\n# PosScheduleOverride \n <SchemaDefinition schemaRef=\"#/components/schemas/PosScheduleOverride\"/>\n\n# ScheduleOverrideMetadata \n <SchemaDefinition schemaRef=\"#/components/schemas/ScheduleOverrideMetadata\"/>\n\n# PosDeleteScheduleOverride \n <SchemaDefinition schemaRef=\"#/components/schemas/PosDeleteScheduleOverride\"/>\n\n"}],"paths":{"/pos/v1/merchant/{merchant_id}/schedules/repeating":{"get":{"tags":["Endpoints"],"summary":"Get merchant schedules","description":"Gets a merchant's schedules.","operationId":"getRepeatingSchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"Successfully retrieved merchant schedule.","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"}},"example":[{"merchant_id":"abc123","schedule_id":"e1a4d35c-3e52-4d7f-8b0c-60c4dc328d9c","name":"DELIVERY","version_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","repeating_schedule_content":{"name":"Weekly Schedule","type":"WEEKLY","metadata":"This is the weekly schedule","rules":[{"days_of_week":["MONDAY","TUESDAY"],"rule_interval":{"start_time":"09:00:00","end_time":"17:00:00"}},{"days_of_week":["WEDNESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00:00","end_time":"16:00:00"}}]},"metadata":{"source":"API"}},{"merchant_id":"def456","schedule_id":"21c8a1d4-5730-4e64-8d82-78c4b451e2a8","name":"PICKUP","version_id":"f5219c4f-8276-4f23-9d32-bf9e700199a3","repeating_schedule_content":{"name":"Weekly Pickup Schedule","type":"WEEKLY","metadata":"This is the weekly pickup schedule","rules":[{"days_of_week":["FRIDAY","SATURDAY","SUNDAY"],"rule_interval":{"start_time":"11:00:00","end_time":"19:00:00"}}]},"metadata":{"source":"Web"}}]}}}}},"put":{"tags":["Endpoints"],"summary":"Create/Update merchant schedule","description":"Creates a merchant schedule if one doesn't exist when updating delivery and pickup schedules.","operationId":"putRepeatingSchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"requestBody":{"description":"The hours per day of the week that this merchant can accept delivery/pickup/catering orders.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosUpdateRepeatingScheduleRequest"},"example":{"intervals":[{"repeating_schedule_rule":["MONDAY","TUESDAY"],"start":"08:00:00","end":"12:00:00"},{"repeating_schedule_rule":["WEDNESDAY","THURSDAY"],"start":"13:30:00","end":"17:30:00"}],"schedule_type":"DELIVERY"}}},"required":true},"responses":{"200":{"description":"Successfully updated merchant schedule.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"},"example":{"merchant_id":"store182","schedule_id":"12345678-abcd-efgh-ijkl-9876543210ab","name":"DELIVERY","version_id":"98765432-ijkl-efgh-abcd-1234567890ab","repeating_schedule_content":{"name":"Example Schedule","type":"WEEKLY","metadata":"1i89aASJDF2","rules":[{"days_of_week":["MONDAY","WEDNESDAY","FRIDAY"],"rule_interval":{"start_time":"09:00","end_time":"18:00"}},{"days_of_week":["TUESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00","end_time":"17:00"}}]},"metadata":{"source":"Example Source","created_by":"John Doe","updated_by":"Jane Doe","create_date":"2023-07-20T12:00:00Z","update_date":"2023-07-20T14:30:00Z","legacy_id":"lkja92ASJd2","description":"system data"}}}}}}}},"/pos/v1/merchant/{merchant_id}/schedules/pickup/{schedule_version}":{"put":{"tags":["Endpoints"],"summary":"Update a pickup schedule","description":"Replaces the weekly schedule of when a merchant is available to accept pickup orders.","operationId":"updatePickupSchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}},{"name":"schedule_version","in":"path","description":"The ID of the schedule version that you want to update.","required":true,"explode":false,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"description":"The hours per day of the week that this merchant can accept pickup orders.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosUpdateRepeatingScheduleRequest"},"example":{"intervals":[{"repeating_schedule_rule":["MONDAY","TUESDAY"],"start":"08:00:00","end":"12:00:00"},{"repeating_schedule_rule":["WEDNESDAY","THURSDAY"],"start":"13:30:00","end":"17:30:00"}],"schedule_type":"DELIVERY"}}},"required":true},"responses":{"200":{"description":"Successfully updated pickup schedule","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"},"example":{"merchant_id":"store182","schedule_id":"12345678-abcd-efgh-ijkl-9876543210ab","name":"DELIVERY","version_id":"98765432-ijkl-efgh-abcd-1234567890ab","repeating_schedule_content":{"name":"Example Schedule","type":"WEEKLY","metadata":"1i89aASJDF2","rules":[{"days_of_week":["MONDAY","WEDNESDAY","FRIDAY"],"rule_interval":{"start_time":"09:00","end_time":"18:00"}},{"days_of_week":["TUESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00","end_time":"17:00"}}]},"metadata":{"source":"Example Source","created_by":"John Doe","updated_by":"Jane Doe","create_date":"2023-07-20T12:00:00Z","update_date":"2023-07-20T14:30:00Z","legacy_id":"lkja92ASJd2","description":"system data"}}}}}}}},"/pos/v1/merchant/{merchant_id}/schedules/delivery/{schedule_version}":{"put":{"tags":["Endpoints"],"summary":"Update a delivery schedule","description":"Replaces the weekly schedule of when a merchant is available to accept delivery orders.","operationId":"updateDeliverySchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}},{"name":"schedule_version","in":"path","description":"The ID of the schedule version that you want to update.","required":true,"explode":false,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"description":"The hours per day of the week that this merchant can accept delivery orders.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosUpdateRepeatingScheduleRequest"},"example":{"intervals":[{"repeating_schedule_rule":["MONDAY","TUESDAY"],"start":"08:00:00","end":"12:00:00"},{"repeating_schedule_rule":["WEDNESDAY","THURSDAY"],"start":"13:30:00","end":"17:30:00"}],"schedule_type":"DELIVERY"}}},"required":true},"responses":{"200":{"description":"Successfully updated delivery schedule","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"},"example":{"merchant_id":"store182","schedule_id":"12345678-abcd-efgh-ijkl-9876543210ab","name":"DELIVERY","version_id":"98765432-ijkl-efgh-abcd-1234567890ab","repeating_schedule_content":{"name":"Example Schedule","type":"WEEKLY","metadata":"1i89aASJDF2","rules":[{"days_of_week":["MONDAY","WEDNESDAY","FRIDAY"],"rule_interval":{"start_time":"09:00","end_time":"18:00"}},{"days_of_week":["TUESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00","end_time":"17:00"}}]},"metadata":{"source":"Example Source","created_by":"John Doe","updated_by":"Jane Doe","create_date":"2023-07-20T12:00:00Z","update_date":"2023-07-20T14:30:00Z","legacy_id":"lkja92ASJd2","description":"system data"}}}}}}}},"/pos/v1/merchant/{merchant_id}/schedules/catering/{schedule_version}":{"put":{"tags":["Endpoints"],"summary":"Update a catering schedule","description":"Replaces the weekly schedule of when a merchant is available to accept catering orders.","operationId":"updateCateringSchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}},{"name":"schedule_version","in":"path","description":"The ID of the schedule version that you want to update.","required":true,"explode":false,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"description":"The hours per day of the week that this merchant can accept catering orders.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosUpdateRepeatingScheduleRequest"},"example":{"intervals":[{"repeating_schedule_rule":["MONDAY","TUESDAY"],"start":"08:00:00","end":"12:00:00"},{"repeating_schedule_rule":["WEDNESDAY","THURSDAY"],"start":"13:30:00","end":"17:30:00"}],"schedule_type":"DELIVERY"}}},"required":true},"responses":{"200":{"description":"Successfully updated catering schedule","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"},"example":{"merchant_id":"store182","schedule_id":"12345678-abcd-efgh-ijkl-9876543210ab","name":"DELIVERY","version_id":"98765432-ijkl-efgh-abcd-1234567890ab","repeating_schedule_content":{"name":"Example Schedule","type":"WEEKLY","metadata":"1i89aASJDF2","rules":[{"days_of_week":["MONDAY","WEDNESDAY","FRIDAY"],"rule_interval":{"start_time":"09:00","end_time":"18:00"}},{"days_of_week":["TUESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00","end_time":"17:00"}}]},"metadata":{"source":"Example Source","created_by":"John Doe","updated_by":"Jane Doe","create_date":"2023-07-20T12:00:00Z","update_date":"2023-07-20T14:30:00Z","legacy_id":"lkja92ASJd2","description":"system data"}}}}}}}},"/pos/v1/merchant/{merchant_id}/schedules/overrides":{"get":{"tags":["Endpoints"],"summary":"Get schedule overrides","description":"Retrieve all schedule overrides for a merchant.","operationId":"getScheduledOverrides","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"Successfully retrieved schedule overrides.","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PosScheduleOverride"}},"example":[{"schedule_id":"123e4567-e89b-12d3-a456-426614174000","merchant_id":"merchant_id_123","name":"DELIVERY","type":"AVAILABLE","metadata":{"source":"source_value","created_by":"John Doe","updated_by":"Jane Smith","create_date":"2023-07-18T12:00:00","update_date":"2023-07-18T14:00:00","legacy_id":"legacy_id_value","description":"Schedule override metadata description"},"local_start_time":"2023-07-18T10:00:00","local_end_time":"2023-07-18T15:00:00","start_time_utc":"2023-07-18T07:00:00Z","end_time_utc":"2023-07-18T12:00:00Z"},{"schedule_id":"98765432-e89b-12d3-a456-426614174000","merchant_id":"merchant_id_456","name":"PICKUP","type":"UNAVAILABLE","metadata":{"source":"source_value_2","created_by":"Alice Johnson","updated_by":"Bob Smith","create_date":"2023-07-19T09:00:00","update_date":"2023-07-19T11:00:00","legacy_id":"legacy_id_value_2","description":"Another Schedule override metadata description"},"local_start_time":"2023-07-19T07:00:00","local_end_time":"2023-07-19T10:00:00","start_time_utc":"2023-07-19T04:00:00Z","end_time_utc":"2023-07-19T07:00:00Z"}]}}}}},"post":{"tags":["Endpoints"],"summary":"Add schedule override","description":"Add a schedule override for a merchant.","operationId":"overrideSchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"requestBody":{"description":"The schedule override to add.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosScheduleOverrideRequest"},"example":{"start":"2023-07-20T12:00:00","end":"2023-07-21T12:00:00","type":"AVAILABLE","schedule_name":"DELIVERY"}}},"required":true},"responses":{"400":{"description":"No user id in request information, or number of availability overrides of exceeds max limit."},"409":{"description":"Schedule override overlaps existing override."},"200":{"description":"Successfully added schedule override.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosScheduleOverrideRequest"},"example":{"start":"2023-07-18T10:00:00","end":"2023-07-18T15:00:00","type":"AVAILABLE","schedule_name":"DELIVERY"}}}}}},"delete":{"tags":["Endpoints"],"summary":"Delete schedule override","description":"Cancels and existing schedule override. Has the effect of updating the end time of the override.","operationId":"deleteScheduleOverride","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"requestBody":{"description":"Reference to the override to be deleted.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosDeleteScheduleOverride"},"example":{"current_end_time":"2023-07-20T12:00:00","type":"AVAILABLE"}}},"required":true},"responses":{"204":{"description":"Override successfully deleted."},"409":{"description":"Schedule override overlaps existing override."}}}},"/pos/v1/merchant/{merchant_id}/schedules/opennow":{"post":{"tags":["Endpoints"],"summary":"Start receiving online orders","description":"Immediately makes the merchant available for Grubhub orders. If the merchant was closed, whether during a regular or custom schedule, from a previous closeNow call, or because of a schedule override, the merchant will become immediately available on Grubhub. This will only affect the status of the merchant on Grubhub; in-store orders will be unaffected.","operationId":"openNow","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"responses":{"503":{"description":"Service requires reconciliation to be enabled"},"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosFullSchedule"},"example":{"statuses":{"DELIVERY":"OPEN","PICKUP":"CLOSED","CATERING":"OPEN","GROUP":"OPEN"},"today_schedule":{"DELIVERY":{"2023-07-20":{"start_time":"09:00:00","end_time":"17:00:00"},"2023-07-21":{"start_time":"09:00:00","end_time":"17:00:00"}},"PICKUP":{"2023-07-20":{"start_time":"10:00:00","end_time":"16:00:00"}}},"overrides_in_effect":[{"schedule_id":"e1a4d35c-3e52-4d7f-8b0c-60c4dc328d9c","merchant_id":"abc123","name":"DELIVERY","type":"WHITEIN","metadata":{"source":"API"},"local_start_time":"2023-07-20T09:00:00","local_end_time":"2023-07-20T17:00:00","start_time_utc":"2023-07-20T06:00:00Z","end_time_utc":"2023-07-20T14:00:00Z"}],"mass_overrides_in_effect":[{"id":"f5219c4f-8276-4f23-9d32-bf9e700199a3","merchant_ids":["def456","ghi789"],"metadata":{},"start_time_utc":"2023-07-21T08:00:00Z","end_time_utc":"2023-07-21T16:00:00Z","start_time_local":"2023-07-21T12:00:00","end_time_local":"2023-07-21T20:00:00"}],"repeating_schedules_in_effect":[{"merchant_id":"jkl012","schedule_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","name":"CATERING","version_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","repeating_schedule_content":{"name":"Weekly Schedule","type":"WEEKLY","metadata":"This is the weekly schedule","rules":[{"days_of_week":["TUESDAY","FRIDAY"],"rule_interval":{"start_time":"11:00:00","end_time":"19:00:00"}}]},"metadata":{"source":"Web"}}],"custom_schedules_in_effect":[{"name":"GROUP","date":"2023-07-21","metadata":{"source":"API","intervals":[{"start_time":"10:00:00","end_time":"14:00:00"},{"start_time":"17:00:00","end_time":"20:00:00"}],"description":"Custom schedule for group orders"}}],"all_schedule_overrides":[{"schedule_id":"e1a4d35c-3e52-4d7f-8b0c-60c4dc328d9c","merchant_id":"abc123","name":"DELIVERY","type":"WHITEIN","metadata":{"source":"API"},"local_start_time":"2023-07-20T09:00:00","local_end_time":"2023-07-20T17:00:00","start_time_utc":"2023-07-20T06:00:00Z","end_time_utc":"2023-07-20T14:00:00Z"}],"all_mass_overrides":[{"id":"f5219c4f-8276-4f23-9d32-bf9e700199a3","merchant_ids":["def456","ghi789"],"metadata":{},"start_time_utc":"2023-07-21T08:00:00Z","end_time_utc":"2023-07-21T16:00:00Z","start_time_local":"2023-07-21T12:00:00","end_time_local":"2023-07-21T20:00:00"}],"all_repeating_schedules":[{"merchant_id":"jkl012","schedule_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","name":"CATERING","version_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","repeating_schedule_content":{"name":"Weekly Schedule","type":"WEEKLY","metadata":"This is the weekly schedule","rules":[{"days_of_week":["TUESDAY","FRIDAY"],"rule_interval":{"start_time":"11:00:00","end_time":"19:00:00"}}]},"metadata":{"source":"Web"}}],"all_custom_schedules":[{"name":"GROUP","date":"2023-07-21","metadata":{"source":"API","intervals":[{"start_time":"10:00:00","end_time":"14:00:00"},{"start_time":"17:00:00","end_time":"20:00:00"}],"description":"Custom schedule for group orders"}}],"managed_delivery_schedules":[{"name":"Weekly","type":"WEEKLY","metadata":"Metadata to store with this repeating schedule","rules":[{"days_of_week":["MONDAY","TUESDAY"],"rule_interval":{"start_time":"09:00:00","end_time":"17:00:00"}},{"days_of_week":["WEDNESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00:00","end_time":"16:00:00"}}]}]}}}},"404":{"description":"Merchant or repeating schedule was not found"}}}},"/pos/v1/merchant/{merchant_id}/schedules/closenow":{"post":{"tags":["Endpoints"],"summary":"Stop online orders","description":"Immediately stops taking Grubhub orders. The merchant will remain listed on the site, but will be shown as closed/not taking orders, overriding any regular or custom schedules, including schedule overrides. This will only affect the status of the merchant on Grubhub; the POS will still be able to process in-store orders.","operationId":"closeNow","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"responses":{"503":{"description":"Service requires reconciliation to be enabled"},"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosFullSchedule"},"example":{"statuses":{"DELIVERY":"OPEN","PICKUP":"CLOSED","CATERING":"OPEN","GROUP":"OPEN"},"today_schedule":{"DELIVERY":{"2023-07-20":{"start_time":"09:00:00","end_time":"17:00:00"},"2023-07-21":{"start_time":"09:00:00","end_time":"17:00:00"}},"PICKUP":{"2023-07-20":{"start_time":"10:00:00","end_time":"16:00:00"}}},"overrides_in_effect":[{"schedule_id":"e1a4d35c-3e52-4d7f-8b0c-60c4dc328d9c","merchant_id":"abc123","name":"DELIVERY","type":"WHITEIN","metadata":{"source":"API"},"local_start_time":"2023-07-20T09:00:00","local_end_time":"2023-07-20T17:00:00","start_time_utc":"2023-07-20T06:00:00Z","end_time_utc":"2023-07-20T14:00:00Z"}],"mass_overrides_in_effect":[{"id":"f5219c4f-8276-4f23-9d32-bf9e700199a3","merchant_ids":["def456","ghi789"],"metadata":{},"start_time_utc":"2023-07-21T08:00:00Z","end_time_utc":"2023-07-21T16:00:00Z","start_time_local":"2023-07-21T12:00:00","end_time_local":"2023-07-21T20:00:00"}],"repeating_schedules_in_effect":[{"merchant_id":"jkl012","schedule_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","name":"CATERING","version_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","repeating_schedule_content":{"name":"Weekly Schedule","type":"WEEKLY","metadata":"This is the weekly schedule","rules":[{"days_of_week":["TUESDAY","FRIDAY"],"rule_interval":{"start_time":"11:00:00","end_time":"19:00:00"}}]},"metadata":{"source":"Web"}}],"custom_schedules_in_effect":[{"name":"GROUP","date":"2023-07-21","metadata":{"source":"API","intervals":[{"start_time":"10:00:00","end_time":"14:00:00"},{"start_time":"17:00:00","end_time":"20:00:00"}],"description":"Custom schedule for group orders"}}],"all_schedule_overrides":[{"schedule_id":"e1a4d35c-3e52-4d7f-8b0c-60c4dc328d9c","merchant_id":"abc123","name":"DELIVERY","type":"WHITEIN","metadata":{"source":"API"},"local_start_time":"2023-07-20T09:00:00","local_end_time":"2023-07-20T17:00:00","start_time_utc":"2023-07-20T06:00:00Z","end_time_utc":"2023-07-20T14:00:00Z"}],"all_mass_overrides":[{"id":"f5219c4f-8276-4f23-9d32-bf9e700199a3","merchant_ids":["def456","ghi789"],"metadata":{},"start_time_utc":"2023-07-21T08:00:00Z","end_time_utc":"2023-07-21T16:00:00Z","start_time_local":"2023-07-21T12:00:00","end_time_local":"2023-07-21T20:00:00"}],"all_repeating_schedules":[{"merchant_id":"jkl012","schedule_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","name":"CATERING","version_id":"a8ef83f8-49a9-4e0c-9b67-9c05c1f05e42","repeating_schedule_content":{"name":"Weekly Schedule","type":"WEEKLY","metadata":"This is the weekly schedule","rules":[{"days_of_week":["TUESDAY","FRIDAY"],"rule_interval":{"start_time":"11:00:00","end_time":"19:00:00"}}]},"metadata":{"source":"Web"}}],"all_custom_schedules":[{"name":"GROUP","date":"2023-07-21","metadata":{"source":"API","intervals":[{"start_time":"10:00:00","end_time":"14:00:00"},{"start_time":"17:00:00","end_time":"20:00:00"}],"description":"Custom schedule for group orders"}}],"managed_delivery_schedules":[{"name":"Weekly","type":"WEEKLY","metadata":"Metadata to store with this repeating schedule","rules":[{"days_of_week":["MONDAY","TUESDAY"],"rule_interval":{"start_time":"09:00:00","end_time":"17:00:00"}},{"days_of_week":["WEDNESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00:00","end_time":"16:00:00"}}]}]}}}},"404":{"description":"Merchant or repeating schedule was not found"}}}},"/pos/v1/merchant/{merchant_id}/schedules/pickup":{"get":{"tags":["Endpoints"],"summary":"Get the pickup schedule","description":"Returns the full weekly pickup hours for the specified merchant.","operationId":"getPickupSchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"Successfully retrieved repeating schedule.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"},"example":{"merchant_id":"store182","schedule_id":"12345678-abcd-efgh-ijkl-9876543210ab","name":"DELIVERY","version_id":"98765432-ijkl-efgh-abcd-1234567890ab","repeating_schedule_content":{"name":"Example Schedule","type":"WEEKLY","metadata":"1i89aASJDF2","rules":[{"days_of_week":["MONDAY","WEDNESDAY","FRIDAY"],"rule_interval":{"start_time":"09:00","end_time":"18:00"}},{"days_of_week":["TUESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00","end_time":"17:00"}}]},"metadata":{"source":"Example Source","created_by":"John Doe","updated_by":"Jane Doe","create_date":"2023-07-20T12:00:00Z","update_date":"2023-07-20T14:30:00Z","legacy_id":"lkja92ASJd2","description":"system data"}}}}}}}},"/pos/v1/merchant/{merchant_id}/schedules/delivery":{"get":{"tags":["Endpoints"],"summary":"Get the delivery schedule","description":"Returns the full weekly delivery hours for the specified merchant.","operationId":"getDeliverySchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"Successfully retrieved repeating schedule.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"},"example":{"merchant_id":"store182","schedule_id":"12345678-abcd-efgh-ijkl-9876543210ab","name":"DELIVERY","version_id":"98765432-ijkl-efgh-abcd-1234567890ab","repeating_schedule_content":{"name":"Example Schedule","type":"WEEKLY","metadata":"1i89aASJDF2","rules":[{"days_of_week":["MONDAY","WEDNESDAY","FRIDAY"],"rule_interval":{"start_time":"09:00","end_time":"18:00"}},{"days_of_week":["TUESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00","end_time":"17:00"}}]},"metadata":{"source":"Example Source","created_by":"John Doe","updated_by":"Jane Doe","create_date":"2023-07-20T12:00:00Z","update_date":"2023-07-20T14:30:00Z","legacy_id":"lkja92ASJd2","description":"system data"}}}}}}}},"/pos/v1/merchant/{merchant_id}/schedules/catering":{"get":{"tags":["Endpoints"],"summary":"Get the catering schedule","description":"Returns the full weekly catering hours for the specified merchant.","operationId":"getCateringSchedule","parameters":[{"name":"merchant_id","in":"path","description":"The short Grubhub ID for the merchant. Corresponds to a single location.","required":true,"explode":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"Successfully retrieved catering schedule.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"},"example":{"merchant_id":"store182","schedule_id":"12345678-abcd-efgh-ijkl-9876543210ab","name":"DELIVERY","version_id":"98765432-ijkl-efgh-abcd-1234567890ab","repeating_schedule_content":{"name":"Example Schedule","type":"WEEKLY","metadata":"1i89aASJDF2","rules":[{"days_of_week":["MONDAY","WEDNESDAY","FRIDAY"],"rule_interval":{"start_time":"09:00","end_time":"18:00"}},{"days_of_week":["TUESDAY","THURSDAY"],"rule_interval":{"start_time":"10:00","end_time":"17:00"}}]},"metadata":{"source":"Example Source","created_by":"John Doe","updated_by":"Jane Doe","create_date":"2023-07-20T12:00:00Z","update_date":"2023-07-20T14:30:00Z","legacy_id":"lkja92ASJd2","description":"system data"}}}}}}}}},"components":{"schemas":{"LocalTime":{"type":"object","properties":{"chronology":{"$ref":"#/components/schemas/Chronology"},"millis_of_day":{"type":"integer","format":"int32"},"hour_of_day":{"type":"integer","format":"int32"},"minute_of_hour":{"type":"integer","format":"int32"},"second_of_minute":{"type":"integer","format":"int32"},"millis_of_second":{"type":"integer","format":"int32"},"fields":{"type":"array","items":{"$ref":"#/components/schemas/DateTimeField"}},"values":{"type":"array","items":{"type":"integer","format":"int32"}},"field_types":{"type":"array","items":{"$ref":"#/components/schemas/DateTimeFieldType"}}}},"PosMerchantRepeatingIntervalRequest":{"required":["end","repeating_schedule_rule","start"],"type":"object","properties":{"repeating_schedule_rule":{"uniqueItems":true,"type":"array","description":"The day of the week that this interval request applies to.","items":{"type":"string","description":"The day of the week that this interval request applies to.","enum":["MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY"]}},"start":{"$ref":"#/components/schemas/LocalTime"},"end":{"$ref":"#/components/schemas/LocalTime"}},"description":"The schedule of a single day of the week within a schedule update request."},"PosUpdateRepeatingScheduleRequest":{"required":["intervals","schedule_type"],"type":"object","properties":{"intervals":{"type":"array","description":"The schedule of a single day of the week within a schedule update request.","items":{"$ref":"#/components/schemas/PosMerchantRepeatingIntervalRequest"}},"schedule_type":{"type":"string","description":"Type of upsert repeating schedule type i.e. DELIVERY, PICKUP, CATERING, and GROUP.","enum":["DELIVERY","PICKUP","CATERING","GROUP"]}},"description":"A schedule update request payload intended to update a merchant's available delivery or pickup hours."},"Chronology":{"type":"object","properties":{"zone":{"$ref":"#/components/schemas/DateTimeZone"}}},"DateTimeField":{"type":"object","properties":{"name":{"type":"string"},"type":{"$ref":"#/components/schemas/DateTimeFieldType"},"supported":{"type":"boolean"},"lenient":{"type":"boolean"},"duration_field":{"$ref":"#/components/schemas/DurationField"},"range_duration_field":{"$ref":"#/components/schemas/DurationField"},"leap_duration_field":{"$ref":"#/components/schemas/DurationField"},"minimum_value":{"type":"integer","format":"int32"},"maximum_value":{"type":"integer","format":"int32"}}},"DateTimeFieldType":{"type":"object","properties":{"name":{"type":"string"},"duration_type":{"$ref":"#/components/schemas/DurationFieldType"},"range_duration_type":{"$ref":"#/components/schemas/DurationFieldType"}}},"DateTimeZone":{"type":"object","properties":{"id":{"type":"string"},"fixed":{"type":"boolean"}}},"DurationField":{"type":"object","properties":{"name":{"type":"string"},"type":{"$ref":"#/components/schemas/DurationFieldType"},"supported":{"type":"boolean"},"unit_millis":{"type":"integer","format":"int64"},"precise":{"type":"boolean"}}},"DurationFieldType":{"type":"object","properties":{"name":{"type":"string"}}},"PosMerchantRepeatingSchedule":{"required":["merchant_id","name","repeating_schedule_content","schedule_id"],"type":"object","properties":{"merchant_id":{"type":"string","description":"The Grubhub or third-party provided external ID for the merchant."},"schedule_id":{"type":"string","description":"The ID of this schedule.","format":"uuid"},"name":{"type":"string","description":"Type of schedule. If not specified, defaults to \"DELIVERY\"","enum":["DELIVERY","PICKUP","CATERING","GROUP"]},"version_id":{"type":"string","description":"The ID of the version of this schedule which changes upon updates to the schedule.","format":"uuid"},"repeating_schedule_content":{"$ref":"#/components/schemas/RepeatingSchedule"},"metadata":{"$ref":"#/components/schemas/RepeatingScheduleMetadata"}},"description":"The repeating weekly schedule of a merchant."},"RepeatingSchedule":{"required":["external_id","name","rules"],"type":"object","properties":{"external_id":{"type":"string","description":"The merchant-set ID for this schedule, which can be used to link it in the `PosNormalizedMenu`."},"name":{"type":"string","description":"The display name for this schedule, e.g. \"Sunday Brunch\""},"type":{"type":"string","description":"How often this schedule repeats. Currently the only valid value is \"WEEKLY\".","enum":["WEEKLY"]},"rules":{"type":"array","description":"A set of non-overlapping time periods.","items":{"$ref":"#/components/schemas/RepeatingScheduleRule"}}},"description":"Information about a weekly schedule during which a menu item may be made available. Typical usages include Breakfast, Lunch, Dinner, Weekend Brunch, etc."},"RepeatingScheduleMetadata":{"required":["source"],"type":"object","properties":{"created_by":{"type":"string","description":"The creator of the schedule"},"updated_by":{"type":"string","description":"The last credential to update the schedule"},"created_date":{"type":"string","description":"The creation date of the schedule","format":"date-time"},"updated_date":{"type":"string","description":"The last update date of the schedule","format":"date-time"},"legacy_id":{"type":"string","description":"The legacy ID of the schedule in MySQL"},"description":{"type":"string","description":"The description for the schedule"},"source":{"type":"string","description":"The source of the creation or update of the repeating schedule"}},"description":"The metadata associated to a specific repeating schedule"},"RepeatingScheduleRule":{"required":["end_time","start_time"],"type":"object","properties":{"days":{"uniqueItems":true,"type":"array","description":"Days of the week for which the time period applies. Must be one of [MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY]","items":{"type":"string","description":"Days of the week for which the time period applies. Must be one of [MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY]","enum":["MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY"]}},"start_time":{"type":"string","description":"The time when this schedule begins on the days listed, in the merchant's local time. Must conform to ISO date and time format","example":"09:30:00.000"},"end_time":{"type":"string","description":"The time when this schedule ends on the days listed, in the merchant's local time. Must conform to ISO date and time format","example":"22:30:00.000"}},"description":"A time period and repetition rule."},"RepeatingScheduleRuleInterval":{"required":["end_time","start_time"],"type":"object","properties":{"start_time":{"$ref":"#/components/schemas/LocalTime"},"end_time":{"$ref":"#/components/schemas/LocalTime"}}},"PosScheduleOverrideRequest":{"required":["type"],"type":"object","properties":{"start":{"type":"string","description":"Start time of the override duration in the merchant's local time. If you do not specify a start and end, then the override will take effect immediately.","format":"date-time"},"end":{"type":"string","description":"End time of the override duration in the merchant's local time. If you do not specify a start and end, then the override will take effect immediately.","format":"date-time"},"type":{"type":"string","description":"Type of schedule override. \"UNAVAILABLE\" is a duration when the merchant should be closed, when normally they would be open. \"AVAILABLE\" is a duration when the merchant should be open, when normally they would be closed.","enum":["WHITEIN","BLACKOUT","UNPAUSE","AVAILABLE","UNAVAILABLE","AVAILABLE","UNAVAILABLE"]},"schedule_name":{"type":"string","description":"Type of schedule. If not specified, defaults to \"DELIVERY\"","enum":["DELIVERY","PICKUP","CATERING","GROUP"]}},"description":"Request body for creating a new schedule override. You must specify both a start or end, or neither. You must include the field schedule_name or by default it will be set to DELIVERY."},"CustomScheduleMetadata":{"required":["intervals","source"],"type":"object","properties":{"created_by":{"type":"string","description":"The creator of the schedule"},"updated_by":{"type":"string","description":"The last credential to update the schedule"},"created_date":{"type":"string","description":"The creation date of the schedule","format":"date-time"},"updated_date":{"type":"string","description":"The last update date of the schedule","format":"date-time"},"legacy_id":{"type":"string","description":"The legacy ID of the schedule in MySQL"},"description":{"type":"string","description":"The description for the schedule"},"source":{"type":"string","description":"The source of the creation or update of the custom schedule"},"intervals":{"type":"array","description":"A set of non-overlapping time periods","items":{"$ref":"#/components/schemas/RepeatingScheduleRuleInterval"}}},"description":"The metadata associated to a specific custom schedule"},"MassScheduleOverrideMetadata":{"type":"object","properties":{"name_filter":{"type":"string","description":"Optional Java Regular Expression used to target specific RepeatingSchedules by name"},"override_type":{"type":"string","description":"The type of a schedule override.  Describes whether the deviation is to open or close unexpectedly.","enum":["BLACKOUT","WHITEIN"]},"schedule_type":{"type":"string","description":"The type of mass schedule override, whether timezones are applied","enum":["LOCAL","ZONED"]},"created_by":{"type":"string","description":"The creator of the schedule"},"updated_by":{"type":"string","description":"The last credential to update the schedule"},"created_date":{"type":"string","description":"The creation date of the schedule","format":"date-time"},"updated_date":{"type":"string","description":"The last update date of the schedule","format":"date-time"},"legacy_id":{"type":"string","description":"The legacy ID of the schedule in MySQL"},"description":{"type":"string","description":"The description for the schedule"}},"description":"Metadata associated to a merchant mass schedule override"},"PeriodSchedule":{"type":"object","properties":{"empty":{"type":"boolean"}},"additionalProperties":{"type":"array","properties":{"empty":{"type":"boolean"}},"description":"A collection of the types of schedules for a merchant, the date on which they begin, and the number of days in each schedule's period. Together, this collection defines the outlines of a merchant's pickup and delivery schedules.<br />Note that the first field, name, is used as the index of the collection.","items":{"$ref":"#/components/schemas/RepeatingScheduleRuleInterval"}},"description":"A collection of the types of schedules for a merchant, the date on which they begin, and the number of days in each schedule's period. Together, this collection defines the outlines of a merchant's pickup and delivery schedules.<br />Note that the first field, name, is used as the index of the collection."},"PosCustomSchedule":{"required":["date","metadata","name"],"type":"object","properties":{"merchant_id":{"type":"string"},"name":{"type":"string","description":"Type of schedule. If not specified, defaults to \"DELIVERY\"","enum":["DELIVERY","PICKUP","CATERING","GROUP"]},"date":{"type":"string","format":"date"},"metadata":{"$ref":"#/components/schemas/CustomScheduleMetadata"}},"description":"All custom schedules associated with this merchant. These are temporary schedules that change the working hours for the merchant for things like holiday or summer hours."},"PosFullSchedule":{"type":"object","properties":{"statuses":{"type":"object","additionalProperties":{"type":"string","description":"The status of a merchant as related to the schedule.","enum":["PAUSED","ONBOARDING","OPEN","CLOSED","WHITED_IN","BLACKED_OUT","GHD_BLACKED_OUT","MASS_BLACKED_OUT"]},"description":"A map of all schedule types (`DELIVERY`, `PICKUP`, etc.) and their current open/close status."},"today_schedule":{"type":"object","properties":{"empty":{"type":"boolean"}},"additionalProperties":{"$ref":"#/components/schemas/PeriodSchedule"},"description":"A collection of the types of schedules for a merchant, the date on which they begin, and the number of days in each schedule's period. Together, this collection defines the outlines of a merchant's pickup and delivery schedules.<br />Note that the first field, name, is used as the index of the collection."},"overrides_in_effect":{"type":"array","description":"The schedules overrides that currently apply to the various schedule types in effect for this merchant.","items":{"$ref":"#/components/schemas/PosScheduleOverride"}},"mass_overrides_in_effect":{"type":"array","description":"The schedule overrides that apply to this and several other merchants, usually of the same merchant group.","items":{"$ref":"#/components/schemas/PosMassScheduleOverride"}},"repeating_schedules_in_effect":{"type":"array","description":"Any repeating weekly schedules in effect for this merchant.","items":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"}},"custom_schedules_in_effect":{"type":"array","description":"Any custom, temporary schedules currently in place. These will take precedence over a repeating schedule of the same type.","items":{"$ref":"#/components/schemas/PosCustomSchedule"}},"all_schedule_overrides":{"type":"array","description":"All previous, current, and future schedule overrides associated with this merchant.","items":{"$ref":"#/components/schemas/PosScheduleOverride"}},"all_mass_overrides":{"type":"array","description":"All mass schedule overrides that have or could affect this merchant's schedule.","items":{"$ref":"#/components/schemas/PosMassScheduleOverride"}},"all_repeating_schedules":{"type":"array","description":"All weekly repeating schedules associated with this merchant. These are used as the default schedule when no custom schedules, or unavailable/available overrides are in effect.","items":{"$ref":"#/components/schemas/PosMerchantRepeatingSchedule"}},"all_custom_schedules":{"type":"array","description":"All custom schedules associated with this merchant. These are temporary schedules that change the working hours for the merchant for things like holiday or summer hours.","items":{"$ref":"#/components/schemas/PosCustomSchedule"}},"managed_delivery_schedules":{"type":"array","description":"The managed delivery schedules for the region that includes this merchant's address.","items":{"$ref":"#/components/schemas/RepeatingSchedule"}}},"description":"Complete schedule information about the merchant, including the status of any alternate schedules or overrides."},"PosMassScheduleOverride":{"type":"object","properties":{"id":{"type":"string","description":"The identifier of the mass override itself.","format":"uuid"},"merchant_ids":{"uniqueItems":true,"type":"array","description":"The IDs of the merchants affected by this mass blackout.","items":{"type":"string","description":"The IDs of the merchants affected by this mass blackout."}},"metadata":{"$ref":"#/components/schemas/MassScheduleOverrideMetadata"},"start_time_utc":{"type":"string","description":"The date and time when this mass override begins in the UTC (Coordinated Universal Time) time zone.","format":"date-time"},"end_time_utc":{"type":"string","description":"The date and time when this mass override ends in the UTC (Coordinated Universal Time) time zone.","format":"date-time"},"start_time_local":{"type":"string","description":"The date and time when this mass override begins in the merchant's local time zone.","format":"date-time"},"end_time_local":{"type":"string","description":"The date and time when this mass override ends in the merchant's local time zone.","format":"date-time"}},"description":"Information about a blackout that applies to multiple merchants; used for groups of merchants to halt online orders or pause ordering during a disaster (Grubhub administrative use only)."},"PosScheduleOverride":{"required":["end_time_utc","local_end_time","local_start_time","merchant_id","name","start_time_utc","type"],"type":"object","properties":{"schedule_id":{"type":"string","description":"The ID of this schedule","format":"uuid"},"merchant_id":{"type":"string","description":"The Grubhub or third-party provided external ID for the merchant."},"name":{"type":"string","description":"Type of schedule. If not specified, defaults to \"DELIVERY\"","enum":["DELIVERY","PICKUP","CATERING","GROUP"]},"type":{"type":"string","description":"Type of schedule override. \"UNAVAILABLE\" is a duration when the merchant should be closed, when normally they would be open. \"AVAILABLE\" is a duration when the merchant should be open, when normally they would be closed.","enum":["WHITEIN","BLACKOUT","UNPAUSE","AVAILABLE","UNAVAILABLE","AVAILABLE","UNAVAILABLE"]},"metadata":{"$ref":"#/components/schemas/ScheduleOverrideMetadata"},"local_start_time":{"type":"string","description":"The time in the merchant's timezone when the override duration starts.","format":"date-time"},"local_end_time":{"type":"string","description":"The time in the merchant's timezone when the override duration ends.","format":"date-time"},"start_time_utc":{"type":"string","description":"The UTC time when the override duration starts.","format":"date-time"},"end_time_utc":{"type":"string","description":"The UTC time when the override duration ends.","format":"date-time"}},"description":"Schedule Override for a merchant. Schedule overrides are ad hoc modifications to a merchant's normal hours of operation on Grubhub."},"ScheduleOverrideMetadata":{"required":["source"],"type":"object","properties":{"created_by":{"type":"string","description":"The creator of the schedule"},"updated_by":{"type":"string","description":"The last credential to update the schedule"},"created_date":{"type":"string","description":"The creation date of the schedule","format":"date-time"},"updated_date":{"type":"string","description":"The last update date of the schedule","format":"date-time"},"legacy_id":{"type":"string","description":"The legacy ID of the schedule in MySQL"},"description":{"type":"string","description":"The description for the schedule"},"source":{"type":"string","description":"The source of the creation or update of the schedule override"}},"description":"The metadata associated to a specific schedule override"},"PosDeleteScheduleOverride":{"required":["current_end_time","type"],"type":"object","properties":{"current_end_time":{"type":"string","description":"Current end time of the override to be deleted. Used as reference for the override.","format":"date-time"},"type":{"type":"string","description":"Type of schedule override. \"UNAVAILABLE\" is a duration when the merchant should be closed, when normally they would be open. \"AVAILABLE\" is a duration when the merchant should be open, when normally they would be closed.","enum":["WHITEIN","BLACKOUT","AVAILABLE","UNAVAILABLE"]}},"description":"Request body for deleting a schedule override."}}}}